//+------------------------------------------------------------------+
//| Copyright 2006, Open Source                                      |
//                                     |
//+------------------------------------------------------------------+


#property copyright "Copyright 2006, Open Source"
#property link      " "
#include <stdlib.mqh>
#define MAGIC 943448
string Name_Expert   = "JPY H4 WPR trader ";

extern double Lots          = 0.3;
extern int    MaxBuyOrders  = 1;  
extern int    MaxSellOrders = 1; 
extern int    BuyWPR        = -96;
extern int    SellWPR       = -4;
extern double lStopLoss     = 55;
extern double sStopLoss     = 55;
extern double TakeProfit    = 190;   
extern double TargetLevel   = 9999;      
extern int    Slippage      = 1;
extern bool   LotIncrease   = false;  
extern bool   IsAcctMini    = false;
extern bool   UseSound      = false;

color  clOpenBuy     = Blue;
color  clCloseBuy    = Aqua;
color  clOpenSell    = Red;
color  clCloseSell   = Violet;
color  clModiBuy     = Blue;
color  clModiSell    = Red;

string NameFileSound = "alert.wav";

double StartingBalance = 0;                 
bool   BuyTradeAllowed    = false;              
bool   SellTradeAllowed    = false;             

//+-------------+
//| Custom init |
//|-------------+
int init()
  {
   if(LotIncrease)
     {
      StartingBalance = AccountBalance()/Lots;
     }

  }

//+----------------+
//| Custom DE-init |
//+----------------+

int deinit()
  {
   return(0);
}
//+---------------------------------------------------+
//| Closes all Buys this symbol only                  |
//+---------------------------------------------------+
void CloseAllThisSymbolBuy()
{
 
   for(int i = 0; i < OrdersTotal(); i++)
       {
       OrderSelect(i, SELECT_BY_POS);
       bool result = false;
       if (OrderSymbol()==Symbol() && OrderMagicNumber() == MAGIC)  
         {
           if ( OrderType() == OP_BUY)  result = OrderClose( OrderTicket(), OrderLots(), MarketInfo(OrderSymbol(), MODE_BID), 5, Red );
         }
       }
      
  return; 
}
   
//+-----------------------------------------------------+
//| Closes all Sells this symbol only                   |
//+-----------------------------------------------------+
void CloseAllThisSymbolSell()
{

   for(int i = 0; i < OrdersTotal(); i++)
      {
      OrderSelect(i, SELECT_BY_POS);
      bool result = false;
      if (OrderSymbol()==Symbol() && OrderMagicNumber() == MAGIC) 
       {
         if ( OrderType() == OP_SELL)  result = OrderClose( OrderTicket(), OrderLots(), MarketInfo(OrderSymbol(), MODE_ASK), 5, Red );
       }
  }
                                 
  return; 
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int start(){
   
   double BuyLots, SellLots, BuyProfit, SellProfit, BuyTarget, SellTarget;
   double OrdersBUY, OrdersSELL;
   int    OrdersPerSymbol;
     
   for(int i=0;i<OrdersTotal();i++)
      {
         OrderSelect(i,SELECT_BY_POS,MODE_TRADES);
         if(OrderSymbol()==Symbol() && OrderMagicNumber()==MAGIC)
           {
           OrdersPerSymbol++;
           if(OrderType()==OP_BUY)  OrdersBUY++;
           if(OrderType()==OP_SELL) OrdersSELL++;
           if(OrderType()==OP_BUY)  BuyLots += OrderLots();
           if(OrderType()==OP_SELL) SellLots += OrderLots();
           if (OrderType() == OP_BUY)  BuyProfit  +=  OrderProfit() + OrderSwap() + OrderCommission();
           if (OrderType() == OP_SELL) SellProfit +=  OrderProfit() + OrderSwap() + OrderCommission();
           }
      }
      
      BuyTarget  = Lots * TargetLevel;   
      SellTarget = Lots * TargetLevel;
   if(!IsAcctMini)
      {
      BuyTarget = BuyTarget * 10;
      SellTarget = SellTarget * 10;
      }
                      
   if(BuyProfit  > BuyTarget)  CloseAllThisSymbolBuy(); 
   if(SellProfit > SellTarget) CloseAllThisSymbolSell();
    
   if(lStopLoss<10){
      Print("StopLoss less than 10");
      return(0);
   }

   if(sStopLoss<10){
      Print("StopLoss less than 10");
      return(0);
   }

   double diWPR0=iWPR(NULL,240,14,PRICE_MEDIAN);
   double diWPR1=iWPR(NULL,240,14,PRICE_MEDIAN);

   if(AccountFreeMargin()<(1000*Lots)){
      Print("We have no money. Free Margin = ", AccountFreeMargin());
      return(0);
   }
   
    if(OrdersPerSymbol==0) BuyTradeAllowed=true;
    if(OrdersPerSymbol==0) SellTradeAllowed=true;
    if(OrdersBUY>MaxBuyOrders-1) BuyTradeAllowed=false;
    if(OrdersSELL>MaxSellOrders-1) SellTradeAllowed=false;
 
      if ((diWPR0<BuyWPR) && BuyTradeAllowed){   
         OpenBuy();
         return(0);
      }

      if ((diWPR1>SellWPR) && SellTradeAllowed){  
         OpenSell();
         return(0);
      }
   
   return (0);
}

void OpenBuy() { 
   double ldLot, ldStop, ldTake; 
   string lsComm; 
   ldLot = GetSizeLot(); 
    if(LotIncrease)
     {
      ldLot=NormalizeDouble(AccountBalance()/StartingBalance,2);
     }
   if(ldLot>100) ldLot = 100;  
   ldStop = GetStopLossBuy();
   ldTake = GetTakeProfitBuy(); 
   lsComm = GetCommentForOrder(); 
   OrderSend(Symbol(),OP_BUY,ldLot,Ask,Slippage,ldStop,ldTake,lsComm,MAGIC,0,clOpenBuy); 
   if (UseSound) PlaySound(NameFileSound); 
} 
void OpenSell() { 
   double ldLot, ldStop, ldTake; 
   string lsComm; 

   ldLot = GetSizeLot(); 
    if(LotIncrease)
     {
      ldLot=NormalizeDouble(AccountBalance()/StartingBalance,2);
     }
   if(ldLot>100) ldLot = 100;  
   ldStop = GetStopLossSell();
   ldTake = GetTakeProfitSell(); 
   lsComm = GetCommentForOrder(); 
   OrderSend(Symbol(),OP_SELL,ldLot,Bid,Slippage,ldStop,ldTake,lsComm,MAGIC,0,clOpenSell); 
   if (UseSound) PlaySound(NameFileSound); 
} 
string GetCommentForOrder() { 	return(Name_Expert); } 
double GetSizeLot()         { 	return(Lots); } 
double GetStopLossBuy()     { 	return(Bid-lStopLoss*Point);} 
double GetStopLossSell()    { 	return(Ask+sStopLoss*Point);}
double GetTakeProfitBuy()   { 	return(Ask+TakeProfit*Point);} 
double GetTakeProfitSell()  { 	return(Bid-TakeProfit*Point);} 

